#ifndef _INTERRUPT_H_INCLUDED_
#define _INTERRUPT_H_INCLUDED_

typedef short softvec_type_t;

typedef void (*softvec_handler_t)(softvec_type_t type, unsigned long sp);

#define INTR_ENABLE  asm volatile("cpsie i")
#define INTR_DISABLE asm volatile("cpsid i")

/* եȥߥ٥ν */
int softvec_init(void);

/* եȥߥ٥ */
int softvec_setintr(softvec_type_t type, softvec_handler_t handler);

/* ̳ߥϥɥ */
void interrupt(softvec_type_t type);

/* HardFaultϥɥ */
int hardfault(unsigned long sp);

#endif
